SUBROUTINE cv(icv,imol,cv_data)

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Passed
  INTEGER :: icv,imol
  DOUBLE PRECISION,DIMENSION(3) :: cv_data
  
  ! Local 
  INTEGER :: i,j,k,cvtype
  INTEGER :: jmol,kmol,itype,jtype,ttype
  INTEGER :: gi,gj,gk
  DOUBLE PRECISION :: rxij, ryij, rzij, rij

  ! Get the CV type
  cvtype = cv_types(icv)

  SELECT CASE (cvtype)

    ! Density
    CASE(1)

      ! Set the CV
      rho_new = DBLE(n_mol_tot)/vol

    ! Steinhardt's Q6
    CASE(2)

       ! Set the CV
       CALL Q6_total(Q6_new)

    CASE DEFAULT

      WRITE(*,*) 'FATAL ERROR: INVALID FLAG TYPE IN CV_TOTAL SUBROUTINE'
      STOP

  END SELECT


  RETURN

END SUBROUTINE cv
