SUBROUTINE cv_total(icv)

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Passed
  INTEGER :: icv
  
  ! Local 
  INTEGER :: i,j,k,cvtype
  INTEGER :: imol,jmol,itype,jtype,ttype
  INTEGER :: gi,gj,gk
  DOUBLE PRECISION :: rxij,ryij,rzij,rij

  ! Get the CV type
  cvtype = cv_types(icv)


  SELECT CASE (cvtype)

    ! Density
    CASE(1)

      ! Set the CV
      rho(my_rank) = DBLE(n_mol_tot)/vol

    ! Steinhardt's Q6
    CASE(2)

       ! Set the CV
       CALL Q6_total(Q6(my_rank))
       
    CASE DEFAULT

      WRITE(*,*) 'FATAL ERROR: INVALID FLAG TYPE IN CV_TOTAL SUBROUTINE'
      STOP

  END SELECT


  RETURN

END SUBROUTINE cv_total
