SUBROUTINE dump_cvs(selector)

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Passed
  INTEGER :: selector

  ! Local
  INTEGER :: itype,icv
  INTEGER :: unitno
  DOUBLE PRECISION :: eng, ke,kt
  CHARACTER(LEN=25) :: filename

  ! Select a case
  SELECT CASE(selector)

    ! Open files for writing
    CASE(0)

      ! Create and appropriate file name
      WRITE(filename,'(A,I0,A)') 'cvs',my_rank,'.out'

      ! Set the unit number
      unitno = 3800

      ! Open the file for writing
      OPEN(UNIT=unitno,FILE=filename,STATUS='UNKNOWN',ACCESS='SEQUENTIAL',ACTION='WRITE')


    ! Write to files
    CASE(2)

      ! Set the unit number
      unitno = 3800

      ! Convert energy
      eng = R*energy/n_mol_tot

      ! Compute the kinetic energy and temperature
      CALL comp_kin_eng(ke,kt)


      ! Write progress information and energy 
      WRITE(unitno,'(2I8,1F12.6,F20.6)',ADVANCE='NO') iblock,istep,temp(my_rank),eng

      ! Write the number of each molecule type
      DO itype =1,n_types
        WRITE(unitno,'(I5)',ADVANCE='NO')n_mol(itype)
      ENDDO   

      ! Write the value of each cv
      WRITE(unitno,'(7F20.6,I10)',ADVANCE='NO')rho(my_rank),krho(my_rank),rhostar(my_rank),Q6(my_rank),kQ6(my_rank),Q6star(my_rank)


      ! Write to advance
      WRITE(unitno,'(A)')'' 


    ! Close files
    CASE(4)
     
      ! Set the unit number
      unitno = 3800

      ! Close the file
      CLOSE(UNIT=unitno)

  END SELECT


  RETURN

END SUBROUTINE dump_cvs
