SUBROUTINE ran_quat(q0i,q1i,q2i,q3i)

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Passed
  DOUBLE PRECISION :: q0i,q1i,q2i,q3i

  ! Local
  DOUBLE PRECISION :: Sq0, Sq1


  ! Initialize Sqs
  Sq0 = 1.0d0
  Sq1 = 1.0d0

  DO
    q0i = 2.0d0 * random(idum) - 1.0d0
    q1i = 2.0d0 * random(idum) - 1.0d0
    Sq0 = q0i * q0i + q1i * q1i
    IF(Sq0 .LT. 1.0d0) EXIT
  END DO

  DO
    q2i = 2.0d0 * random(idum) - 1.0d0
    q3i = 2.0d0 * random(idum) - 1.0d0
    Sq1 = q2i * q2i + q3i * q3i
    IF(Sq1 .LT. 1.0d0) EXIT
  END DO

  ! Finalize 
  q0i = q0i
  q1i = q1i
  q2i = q2i * dSQRT((1.0d0 - Sq0) / Sq1)
  q3i = q3i * dSQRT((1.0d0 - Sq0) / Sq1)


  RETURN

END SUBROUTINE ran_quat
