SUBROUTINE remove_vcom

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  INTEGER :: imol,isite,itype
  DOUBLE PRECISION :: px,py,pz
  DOUBLE PRECISION :: vxc,vyc,vzc

  ! Compute center of mass momentum
  px = 0.0d0
  py = 0.0d0
  pz = 0.0d0
  DO imol = 1,n_mol_tot
    px = px + mol_mass(1)*vx(imol)
    py = py + mol_mass(1)*vy(imol)
    pz = pz + mol_mass(1)*vz(imol)
  ENDDO
  vxc = px/(DBLE(n_mol_tot)*mol_mass(1))
  vyc = py/(DBLE(n_mol_tot)*mol_mass(1))
  vzc = pz/(DBLE(n_mol_tot)*mol_mass(1))

  ! Subtract center of mass velocity
  DO imol = 1,n_mol_tot
    vx(imol) = vx(imol) - vxc
    vy(imol) = vy(imol) - vyc
    vz(imol) = vz(imol) - vzc
  ENDDO

END SUBROUTINE remove_vcom

