SUBROUTINE rot_matrix(tpose,quat, rotmat)

  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Passed
  INTEGER :: tpose,i,j
  DOUBLE PRECISION,DIMENSION(4) :: quat
  DOUBLE PRECISION,DIMENSION(3,3) :: rotmat

  ! Local 
  INTEGER :: itype,isite
  DOUBLE PRECISION :: q0,q1,q2,q3

  ! Extract quaternion elements
  q0 = quat(1)
  q1 = quat(2)
  q2 = quat(3)
  q3 = quat(4) 

  ! Calculate the rotation matrix A
  IF(tpose .EQ. 0) THEN

    rotmat(1,1) = q0**2 + q1**2 - q2**2 - q3**2
    rotmat(2,1) = 2.0d0*(q1*q2 - q0*q3)
    rotmat(3,1) = 2.0d0*(q1*q3 + q0*q2)

    rotmat(1,2) = 2.0d0*(q1*q2 + q0*q3)
    rotmat(2,2) = q0**2 - q1**2 + q2**2 - q3**2
    rotmat(3,2) = 2.0d0*(q2*q3 - q0*q1)

    rotmat(1,3) = 2.0d0*(q1*q3 - q0*q2)
    rotmat(2,3) = 2.0d0*(q2*q3 + q0*q1)
    rotmat(3,3) = q0**2 - q1**2 - q2**2 + q3**2

  ELSEIF(tpose .EQ. 1) THEN

    rotmat(1,1) = q0**2 + q1**2 - q2**2 - q3**2
    rotmat(2,1) = 2.0d0*(q1*q2 + q0*q3)
    rotmat(3,1) = 2.0d0*(q1*q3 - q0*q2)

    rotmat(1,2) = 2.0d0*(q1*q2 - q0*q3)
    rotmat(2,2) = q0**2 - q1**2 + q2**2 - q3**2
    rotmat(3,2) = 2.0d0*(q2*q3 + q0*q1)

    rotmat(1,3) = 2.0d0*(q1*q3 + q0*q2)
    rotmat(2,3) = 2.0d0*(q2*q3 - q0*q1)
    rotmat(3,3) = q0**2 - q1**2 - q2**2 + q3**2

  ENDIF


  RETURN

END SUBROUTINE rot_matrix

