SUBROUTINE write_restart

  USE global
  IMPLICIT NONE
  INCLUDE 'mpif.h'

  ! Local
  INTEGER :: imol,itype,isite,n_sites_tot
  CHARACTER(LEN=25) :: filename
  CHARACTER(LEN=10) :: mol


  ! Write com positions and quaternions

  ! Create and appropriate file name
  WRITE(filename,'(A,I0,A)') 'restart_b',my_rank,'.xyz'

  OPEN(UNIT=30,FILE=filename,STATUS='UNKNOWN',ACCESS='SEQUENTIAL',ACTION='WRITE')
  
    ! Write the total number of molecules
    WRITE(30,'(I10)', ADVANCE='NO') n_mol_tot
    
    ! Write to advance to the next line
    WRITE(30,*)

    ! Write the box dimensions
    WRITE(30,'(3F17.9)') box(1),box(2),box(3) 

    ! Write the coordinates to file (sorting by type)
    DO itype = 1,n_types

      ! Loop over the molecules
      DO imol = 1,n_mol_tot

        ! Check that it is the right type
        IF(mol_type(imol) .EQ. itype) THEN
        
          ! Write the type and coordinates to file
          WRITE(30,'(A4,7F17.9)') mol_name(itype),rx(imol),ry(imol),rz(imol),&
                                  &q0(imol),q1(imol),q2(imol),q3(imol)     

        ENDIF
      ENDDO
    ENDDO

  CLOSE(UNIT=30)


  RETURN

END SUBROUTINE write_restart
